/*
 * Decompiled with CFR 0.152.
 * 
 * Could not load the following classes:
 *  com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutObjectVO
 *  com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutTotalVO
 *  com.deepexi.scd.common.enums.business.CalculateTotalTypeEnum
 *  com.deepexi.spa.commons.utils.CollectionUtils
 *  com.deepexi.spa.commons.utils.StringUtils
 *  org.springframework.stereotype.Component
 */
package com.deepexi.scd.calculate.business;

import com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutObjectVO;
import com.deepexi.scd.calculate.domain.vo.CalculateReportLayoutTotalVO;
import com.deepexi.scd.common.enums.business.CalculateTotalTypeEnum;
import com.deepexi.spa.commons.utils.CollectionUtils;
import com.deepexi.spa.commons.utils.StringUtils;
import java.math.BigDecimal;
import java.text.DecimalFormat;
import java.util.ArrayList;
import java.util.Collection;
import java.util.LinkedHashMap;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.stream.Collectors;
import org.springframework.stereotype.Component;

@Component
public class CalculateReportLayoutCommon {
    public List<CalculateReportLayoutTotalVO> remakeReportTotal(List<CalculateReportLayoutTotalVO> reportTotals) {
        reportTotals = reportTotals.stream().filter(f -> CalculateTotalTypeEnum.TOTAL.getKey().equals(f.getTotalCategory())).collect(Collectors.toList());
        BigDecimal mainValue = BigDecimal.ZERO;
        Optional<CalculateReportLayoutTotalVO> mainOptional = reportTotals.stream().filter(f -> "MAIN".equals(f.getTotalType())).findFirst();
        if (mainOptional.isPresent()) {
            mainValue = this.convert2BigDecimal(mainOptional.get().getTotalValueStr());
            mainOptional.get().setTotalName("包括购入和输出的电力和热力产生的C0₂排放量");
        }
        BigDecimal excludeValue = BigDecimal.ZERO;
        Optional<String> excludeValueOptional = reportTotals.stream().filter(f -> "EDGE".equals(f.getTotalType()) && f.getTotalName().startsWith("电力热力")).map(CalculateReportLayoutTotalVO::getTotalValueStr).findFirst();
        if (excludeValueOptional.isPresent()) {
            excludeValue = this.convert2BigDecimal(excludeValueOptional.get());
        }
        CalculateReportLayoutTotalVO excludeTotal = new CalculateReportLayoutTotalVO();
        excludeTotal.setTotalCategory("TOTAL");
        excludeTotal.setTotalType("MAIN");
        excludeTotal.setTotalName("不包括购入和输出的电力和热力产生的CO₂排放量");
        excludeTotal.setTotalValueStr(this.formatValue(mainValue.subtract(excludeValue)));
        excludeTotal.setSequenceNo(Integer.valueOf(0));
        reportTotals.add(0, excludeTotal);
        List<CalculateReportLayoutTotalVO> newReportTotals = this.getReportTotalType(reportTotals);
        newReportTotals.removeAll(newReportTotals.stream().filter(f -> "EDGE".equals(f.getTotalType()) && "电力热力排放量".equals(f.getTotalName())).collect(Collectors.toList()));
        newReportTotals.addAll(reportTotals.stream().filter(f -> "TABLE".equals(f.getTotalType()) && f.getTotalName().endsWith("力排放量")).collect(Collectors.toList()));
        return newReportTotals;
    }

    public List<CalculateReportLayoutTotalVO> getReportTotalType(List<CalculateReportLayoutTotalVO> reportTotals) {
        ArrayList<String> totalTypes = new ArrayList<String>();
        totalTypes.add("META");
        totalTypes.add("TABLE");
        return reportTotals.stream().filter(f -> !totalTypes.contains(f.getTotalType())).collect(Collectors.toList());
    }

    public String formatValue(String value) {
        if (StringUtils.isBlank((CharSequence)value)) {
            return "";
        }
        return this.formatValue(this.convert2BigDecimal(value));
    }

    public String formatValue(BigDecimal value) {
        DecimalFormat df = new DecimalFormat("#,##0.####");
        return df.format(value);
    }

    public BigDecimal convert2BigDecimal(String value) {
        if (StringUtils.isBlank((CharSequence)value)) {
            return BigDecimal.ZERO;
        }
        return new BigDecimal(value.replace(",", ""));
    }

    public void changeTableList(LinkedHashMap<String, List<CalculateReportLayoutObjectVO>> tableMap) {
        for (Map.Entry<String, List<CalculateReportLayoutObjectVO>> entry : tableMap.entrySet()) {
            List newLayoutObjectVOList = entry.getValue().stream().filter(f -> CollectionUtils.isEmpty((Collection)f.getColumnList())).collect(Collectors.toList());
            newLayoutObjectVOList.addAll(entry.getValue().stream().filter(f -> CollectionUtils.isNotEmpty((Collection)f.getColumnList())).collect(Collectors.toList()));
            entry.setValue(newLayoutObjectVOList);
        }
    }
}

